# Class StreamTableSink

java.lang.Object
uk.ac.starlink.table.StreamTableSink

All Implemented Interfaces:
  `TableSink`

public abstract class StreamTableSink extends Object implements TableSink
TableSink which turns its accepted data into a one-pass table and does something with it (calls `scanTable(StarTable)` on it). This effectively allows you to 'push' table data by writing it to this TableSink rather than 'pulling' it by implementing a `RowSequence`; the latter may be a less obvious or more fiddly way to work. Note however this will only work for `scanTable` implementations which need only a single pass of the data.

See `TableSink` for usage rules.

Since:
  8 Aug 2007
Author:
  Mark Taylor

## Constructor Summary

Constructors
Constructor
Description
`StreamTableSink()`

## Method Summary

Modifier and Type
Method
Description
`void`
`acceptMetadata(StarTable meta)`
Takes delivery of a row-less `StarTable` object which defines the metadata of the table to be transmitted.
`void`
`acceptRow(Object[] row)`
Takes delivery of one row of data.
`void`
`endRows()`
Signals that there are no more rows to be transmitted.
`protected abstract void`
`scanTable(StarTable table)`
Does something or other with the table whose data is being pushed into this sink.

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### StreamTableSink

public StreamTableSink()

## Method Details

### scanTable

protected abstract void scanTable(StarTable table) throws IOException
Does something or other with the table whose data is being pushed into this sink. The only data access which will work is a single call to `StarTable.getRowSequence()`. Subsequent `getRowSequence` calls will result in a `UnrepeatableSequenceException`. This method is called in a separate thread than the one in which the `accept*` calls are made; but any exceptions thrown here are passed back to the latter thread.

Parameters:
  `table` - table to consume
Throws:
  `IOException`

### acceptMetadata

public void acceptMetadata(StarTable meta) throws TableFormatException
Description copied from interface: `TableSink`
Takes delivery of a row-less `StarTable` object which defines the metadata of the table to be transmitted. If the number of rows that will be transmitted via subsequent calls to `acceptRow` is known, this value should be made available as the row count of `meta` (`StarTable.getRowCount()`); if it is not known, the row count should be -1. However, this object should not attempt to read any of `meta`'s cell data.

The data to be transmitted in subsequent calls of `acceptRow` must match the metadata transmitted in this call in the same way that rows of a StarTable must match its own metadata (number and content clases of columns etc). If this sink cannot dispose of a table corresponding to `meta` then it may throw a TableFormatException - this may be the case if for instance `meta` has columns with types that this sink can't deal with.

Specified by:
  `acceptMetadata` in interface `TableSink`
Parameters:
  `meta` - table metadata object
Throws:
  `TableFormatException` - if this sink cannot accept table rows matching the given metadata

### acceptRow

public void acceptRow(Object[] row) throws IOException
Description copied from interface: `TableSink`
Takes delivery of one row of data. `row` is an array of objects comprising the contents of one row of the table being transmitted. The number and classes of the elements of `row` are described by the metadata object previously accepted.

Specified by:
  `acceptRow` in interface `TableSink`
Parameters:
  `row` - table data row
Throws:
  `IOException`

### endRows

public void endRows() throws IOException
Description copied from interface: `TableSink`
Signals that there are no more rows to be transmitted.

Specified by:
  `endRows` in interface `TableSink`
Throws:
  `IOException`